#!/usr/bin/python -OO

import sys, re
import pygtk
pygtk.require('2.0')
import gtk.glade
import gobject
import gladew
import Image

import os, new, types

# for  xcurs
# import parsexcursor
import filesel
import xcursorlist

glade_fname = 'xcurs.glade'
# def_fname = 'data/xcurs.png'

# def_dir = 'themes/gold/cursors/'

def new_rshort(idnum, name):
    return {'id': idnum, 'name': name}

themedir = 'themes/Silver/cursors/';

class xcursMain(gladew.GladeWidget):    
    def __init__(self):
        self.initialize(glade_fname, 'main')
        self.widgets.get_widget('main').connect('destroy', gtk.mainquit);
        self.preview = self.widgets.get_widget('curprev')
        self.bigview = self.widgets.get_widget('curbig')
        self.cursorres = self.widgets.get_widget('cursorres');
        self.sel_cursor = None 
        self.ch_imageres = None 
        self.clist = None # initially no cursor loaded
        self.init_cursorlist();
        self.init_imagelist();
        self.populate_curlist()
        # self.mappix = gtk.gdk.pixbuf_new_from_file(def_fname)
        self.display_cursor(self.sel_cursor);
        self.set_text("Please open some xcursor directory");
        if(len(sys.argv) > 1):
            self.load_cursor(sys.argv[1])
        
        # self.sel_image = 0
        
        # self.sel_route, self.sel_vertex = -1, -1
        # self.vert_dragging = 0; self.vert_dragged = None
        
        # mapdim = (self.mappix.get_height(), self.mappix.get_width())

    def init_cursorlist(self):
        self.cursorlist = self.widgets.get_widget('curlist')
        self.curselmodel = gtk.ListStore(gobject.TYPE_PYOBJECT, gobject.TYPE_STRING);
        renderer = gtk.CellRendererText()
        self.cursorlist.set_model(self.curselmodel);
        column = gtk.TreeViewColumn("Cursors", renderer, text=1)
        self.cursorlist.append_column(column)
        selection = self.cursorlist.get_selection()
        selection.connect("changed", self.change_cursor);

    def populate_curlist(self):
        self.curselmodel.clear() # empty it first
        if self.clist == None:
            return # no content to render
        curnames = self.clist.get_loaded_cursors();
        curnames.sort();
        for i in curnames:
            #if cdeflist.get_cursor(i).islink:
            #    continue
            iter = self.curselmodel.append()
            rshort = new_rshort(i, i)
            self.curselmodel.set(iter, 0, rshort)
            self.curselmodel.set(iter, 1, rshort['name'])
            # self.display_route(rshort['id'])
            self.sel_route = rshort['id']

    def change_cursor(self, sel):
        model, iter = sel.get_selected()
        # print "data: ", model.get_value(iter, 0) # ['id'];        
        self.display_cursor(model.get_value(iter, 0)['id'])
        
    def init_imagelist(self):
        if self.clist == None:
            str = ("", "");
        else:
            xc = self.clist.get_cursor(self.sel_cursor);
            str = xc.get_sizes();
        self.cursorres.set_popdown_strings(str);
        isel = self.imagesel = self.widgets.get_widget('imagesel')
        ism = self.iselmodel = gtk.ListStore(gobject.TYPE_PYOBJECT, gobject.TYPE_STRING);
        isel.set_model(ism)
        column = gtk.TreeViewColumn("Images", gtk.CellRendererText(), text=1)
        isel.append_column(column)
        isel.get_selection().connect("changed", self.change_image);

    def change_image(self, sel):
        model, iter = sel.get_selected()        
        # print "data2: ", model, iter
        if iter == None: # we just were emptied.
            self.sel_image = 0 # select first image.
        else:
            self.sel_image = int(model.get_value(iter, 0)['id']);
        self.fix_datadisplay();
        self.fix_viewsizes();
        
    def on_cursorres_activate(self, widget, *arf):        
        # print "curresa"
        nres = widget.get_text();
        if (nres == ""): # first 'empty' call.
            return
        # print "%s:%s" % (self.ch_imageres, nres)
        if (nres != self.ch_imageres):
            self.ch_imageres = nres
            self.populate_imagelist()
            self.fix_viewsizes()

    def display_cursor(self, curname):
        self.sel_cursor = curname
        self.sel_image = 0
        if self.clist == None:
            return # no content to render
        xc = self.clist.get_cursor(curname);
        # self.ch_imageres = xc.get_sizes()[0];
        self.populate_imagelist()
        text = curname + " ";
        if (xc.islink):
            text += " symlink to %s" % xc.rpath;
        self.set_text(text)
        self.cursorres.set_popdown_strings(xc.get_sizes());
        self.fix_viewsizes()

    def set_text(self, text):
        self.widgets.get_widget('curname').set_text(text);
        
    def populate_imagelist(self):
        isel = self.iselmodel
        isel.clear(); g = 0
        if self.clist == None:
            return # no content to populate
        xc = self.clist.get_cursor(self.sel_cursor);
        for i in xc.get_images_str(self.ch_imageres):
            iter = isel.append();
            iselh = new_rshort(g, i);
            isel.set(iter, 0, iselh)
            isel.set(iter, 1, iselh['name'])
            g+=1    
        
    def fix_viewsizes(self):        
        #self.bigview.queue_draw()
        #self.preview.queue_draw()
        # xc = cdeflist.get_cursor(self.sel_cursor);    
        apply(self.preview.set_size_request, self.plain_resolution())
        self.on_curbig_configure_event(self.bigview)
        self.bigview.queue_draw();
        
    def fix_datadisplay(self):
        xhot = self.widgets.get_widget('xhot')
        xhot.set_value(self.get_current_image().xhot);
        yhot = self.widgets.get_widget('yhot')
        yhot.set_value(self.get_current_image().yhot);
        delay = self.widgets.get_widget('delay')
        delay.set_value(self.get_current_image().delay);
        
    def get_current_image(self):
        return self.clist.get_cursor(self.sel_cursor).get_image_by_size(
            self.ch_imageres, self.sel_image)
    
    def on_curbig_button_release_event(self, widget, event):
        # print "bre"
        if self.clist == None:
            return # nothing to do
        xc = self.get_current_image();
        bbox = widget.get_allocation();
        res = self.plain_resolution();
        espot = (event.x, event.y);
        atx = int((espot[0]*res[0]) / bbox.width);
        aty = int((espot[1]*res[1]) / bbox.height);
        xc.xhot = atx; xc.yhot = aty
        self.draw_bigcur();
        
    def on_delay_changed(self, widget):
        delay = widget.get_value();
        self.get_current_image().delay = delay
        
    def on_xhot_changed(self, widget):
        xhot = widget.get_value();
        self.get_current_image().xhot = xhot
        
    def on_yhot_changed(self, widget):
        yhot = widget.get_value();
        self.get_current_image().yhot = yhot
        
    def add_image(self, fname):
        print "adding " , fname
        if self.clist == None:
            return # Nothing we can do.
        im = Image.open(fname) # gtk.gdk.pixbuf_new_from_file(fname)
        print im.format, im.size, im.mode
        if (im.mode != "RGBA"):
            print "Image must have Alpha channel. aborting import"
            return
        # print im.getdata()[:40]
        w, h = im.size
        getpixel = im.getpixel
        imdata = [];
        for y in range(h):
            for x in range(w):
                td = im.getpixel((x, y))
                # print "%d %d %x" % (x, y,
                imdata.append(long((long(td[3]) << 24) | (td[0] << 16) | (td[1] << 8) | td[2]))
        xc = self.clist.get_cursor(self.sel_cursor)
        xc.add_image(w, h, imdata)
        print "Adding to ", im.size, self.sel_cursor
        
        self.display_cursor(self.sel_cursor)
        

    def add_vertex(self):
        self.display_route(rter.get_cur_route().ref)
        self.sel_vertex = len(rter.get_cur_route().points) - 1       
        

    def on_curbig_expose_event(self, widget, *arfs):
        #route.cconv.set_map(self.mappix.get_width(), self.mappix.get_height());
        #route.cconv.set_view_11(self.drawa.get_allocation().width,
        #                  self.drawa.get_allocation().height)
        if self.clist == None:
            return gtk.FALSE
        self.style = self.bigview.get_style()
        self.gc = self.style.fg_gc[gtk.STATE_NORMAL]
        self.draw_bigcur();
        #self.draw_map()
        #self.draw_routes()
        return gtk.TRUE
    
    def on_curbig_configure_event(self, widget, *arfs):
        # print "configured";
        if self.clist == None:
            return # nothing we can do
        praa = self.bigview.get_allocation();
        xc = self.clist.get_cursor(self.sel_cursor);
        image = xc.get_image_by_size(self.ch_imageres, self.sel_image);
        data = image.get_gdkp();
        self.sel_cur_pixmap = gtk.gdk.pixbuf_new_from_inline(len(data), data, 1)
        #self.preview_back = self.sel_cur_pixmap.scale_simple(
        #    praa.width, daa.height, gtk.gdk
        
        
    def on_add_image_clicked(self, *arfs):
        self.show_add_image()

    def on_remove_image_clicked(self, *arfs):
        # get the cursor that's selected
        xc = self.clist.get_cursor(self.sel_cursor)        
        # remove current image
        xc.rm_image_by_size(self.ch_imageres, self.sel_image);
        # refresh this list
        self.display_cursor(self.sel_cursor)
        
    def on_save1_activate(self, *a):
        # rter.dump();
        fname = filesel.select_file('Select directory', gtk.TRUE, 0)
        if fname == None:
            return
        self.save_cursor(fname)

    def on_open1_activate(self, *a):
        fname = filesel.select_file('Select xcursor', gtk.TRUE, 0)
        if fname == None:
            return
        self.load_cursor(fname)

    def on_export1_activate(self, *a):
        dir_name = filesel.select_file('Select directory to save images', gtk.TRUE, 0)
        if dir_name == None:
            return        
        self.save_images(self.todir(dir_name))

    def todir(self, fname):
        if(os.path.isfile(fname)):
            fname = os.path.dirname(fname)
        if(fname[-1:] != '/'): fname += '/'
        return fname        

    def load_cursor(self, fname):
        print "Got filename: %s" % fname
        clist = xcursorlist.XCursorList();
        fname = self.todir(fname)
        clist.load_dir(fname)
        if len(clist.get_loaded_cursors()) == 0:
            self.set_text('No suitable files!')
            return
        self.clist = clist
        self.sel_cursor = self.clist.get_loaded_cursors()[0];
        self.ch_imageres = self.clist.get_cursor(self.sel_cursor).get_sizes()[0]
        self.populate_curlist()
        self.display_cursor(self.sel_cursor)

    def save_cursor(self, fname):
        if(self.clist == None):
            return        
        fname = self.todir(fname);
        print "Saving to %s" % fname
        self.clist.save_to(fname)

    def save_images(self, dir_name):
        #print "Saving %s" % self.sel_cursor
        #print "Saving to %s" % dir_name
        if self.clist == None:
            self.set_text("Consider selecting exported cursor first.");
            return;
        fnamebase = dir_name + self.sel_cursor
        xc = self.clist.get_cursor(self.sel_cursor);
        sizes = xc.get_sizes();
        # save all sizes.
        for size in sizes:
            # only get these to get number of images of this size..
            count = 0;
            for img in xc.get_images_str ( size ):                
                image = xc.get_image_by_size ( size, count );
                data = image.get_gdkp();
                pixmap = gtk.gdk.pixbuf_new_from_inline( len (data), data, 1 );
                fname = "%s-%s-%02d.png" % (fnamebase, size, count);
                # print "Saving %s" % fname
                pixmap.save(fname, "png");
                count += 1;

    def show_add_image(self):
        addimage.rexec = self.add_image
        addimage.show()

    def plain_resolution(self):
        resstr = self.ch_imageres
        return map(int, re.findall("\s*(\d+)x(\d+)", resstr)[0])

    def draw_bigcur(self):
        if self.clist == None:
            return # nothing to do..
        self.draw_cursor(self.bigview, 1)
        self.draw_cursor(self.preview, 0)
        
    def draw_cursor(self, drawa, scale):
        daa = drawa.get_allocation();
        # xc = cdeflist.get_cursor(self.sel_cursor);
        # image = xc.get_image_by_size(self.ch_imageres, self.sel_image);
        # data = image.get_gdkp();
        # self.mappix = gtk.gdk.pixbuf_new_from_inline(len(data), data, 1)
        # print "ene ", eke.width        
        if scale:
            mene = self.sel_cur_pixmap.scale_simple(daa.width, daa.height, gtk.gdk.INTERP_NEAREST)
        else:
            mene = self.sel_cur_pixmap
            
        drawa.window.draw_rectangle(
            drawa.get_style().bg_gc[0], 1, 0, 0, daa.width, daa.height )
        
        mene.render_to_drawable(drawa.window, self.gc, 0, 0, 0, 0, -1, -1, 0, 0, 0);
        if scale: # must be big view, so draw 'hotspot'.
            self.draw_hotspot(drawa, daa)
        return
    def draw_hotspot(self, drawa, bbox):
        xc = self.clist.get_cursor(self.sel_cursor).get_image_by_size(
            self.ch_imageres, self.sel_image)
        res = self.plain_resolution();
        hspot = (xc.xhot, xc.yhot);
        atx = (hspot[0]+0.5) * bbox.width/res[0];
        aty = (hspot[1]+0.5) * bbox.height/res[1];
        drawa.window.draw_line(drawa.get_style().black_gc,
                               atx, 0, atx, bbox.height)
        drawa.window.draw_line(drawa.get_style().black_gc,
                               0, aty, bbox.width, aty)                               
        

    def handle_quit(self, widget):        
        gtk.main_quit()



class AddImageDiag(gladew.GladeWidget):
    def noop(*a): pass
    def __init__(self):
        self.rexec = self.noop
        self.initialize(glade_fname, 'themeinfo')            

    def on_cancel_button1_clicked(self, *args):
        self.widgets.get_widget('themeinfo').hide();
        
    def on_ok_button1_clicked(self, *args):
        self.widgets.get_widget('themeinfo').hide();
        # self.rname = self.widgets.get_widget('rname').get_text();
        self.rname = self.widgets.get_widget('themeinfo').get_filename();
        self.rexec(self.rname);
        # self.rexec(self.rname);
        # routes.append(Route(self.rname, mapdim))
        #rter.add_route(Route(self.rname, mapdim))
        
    def show(self):
        self.widgets.get_widget('themeinfo').show();
        
ikk = xcursMain()
addimage = AddImageDiag()

gtk.main()
